#ifndef YYMAXDEPTH
#define YYMAXDEPTH 200
#endif
#ifndef YYREDMAX
#define YYREDMAX 1000
#endif
#define PCYYFLAG -4096
#define WAS0ERR 0
#define WAS1ERR 1
#define WAS2ERR 2
#define WAS3ERR 3
#define yyclearin pcyytoken = -1
#define yyerrok   pcyyerrfl = 0
YYSTYPE yyv[YYMAXDEPTH];     /* value stack */
int pcyyerrct = 0;           /* error count */
int pcyyerrfl = 0;           /* error flag */
int redseq[YYREDMAX];
int redcnt = 0;
int pcyytoken = -1;          /* input token */
#ifdef YYDEBUG
FILE *errfile;
#endif


int yyparse()
{
#ifdef YYSHORT
  const short *yyxi;
#else
  const int *yyxi;
#endif
#ifdef YYASTFLAG
    int ti; int tj;
#endif

#ifdef YYDEBUG
int tmptoken;
static int init=1;
#endif
  int statestack[YYMAXDEPTH]; /* state stack */
  int      j, m;              /* working index */
  YYSTYPE *yypvt;
  int      tmpstate, *yyps, n;
  YYSTYPE *yypv;


  tmpstate = 0;
  pcyytoken = -1;


#ifdef YYDEBUG
  if (init)
  {
     errfile = fopen("ydb.err","w");
     if (errfile == NULL )
     {
	fprintf(stderr,"Can not open trace info file\n");
	return (1);
     }
     init = 0;
  }
#endif
#ifdef YYDEBUG
  tmptoken = -1;
#endif


  pcyyerrct = 0;
  pcyyerrfl = 0;
  yyps = &statestack[-1];
  yypv = &yyv[-1];


  enstack:    /* push stack */
#ifdef YYDEBUG
   fprintf(errfile, "at state %d, next token %d\n", tmpstate, tmptoken);
#endif
    if (++yyps - &statestack[YYMAXDEPTH-1] > 0) {
      yyerror("pcyacc internal stack overflow");
#ifdef YYDEBUG
						fclose(errfile);
#endif
      return(1);
    }
    *yyps = tmpstate;
    ++yypv;
    *yypv = yyval;


  newstate:
    n = yypact[tmpstate];
    if (n <= PCYYFLAG) goto defaultact; /*  a simple state */


    if (pcyytoken < 0) if ((pcyytoken=yylex()) < 0) pcyytoken = 0;
    if ((n += pcyytoken) < 0 || n >= YYLAST) goto defaultact;


    if (yychk[n=yyact[n]] == pcyytoken) { /* a shift */
#ifdef YYDEBUG
      tmptoken  = pcyytoken;
#endif
      pcyytoken = -1;
      yyval = yylval;
      tmpstate = n;
      if (pcyyerrfl > 0) --pcyyerrfl;
      goto enstack;
    }


  defaultact:


    if ((n=yydef[tmpstate]) == -2) {
      if (pcyytoken < 0) if ((pcyytoken=yylex())<0) pcyytoken = 0;
      for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=tmpstate); yyxi += 2);
      while (*(yyxi+=2) >= 0) if (*yyxi == pcyytoken) break;
      if ((n=yyxi[1]) < 0) { /* an accept action */
#ifdef YYASTFLAG
	  yytfilep = fopen(yytfilen, "w");
	  if (yytfilep == NULL) {
	    fprintf(stderr, "Can't open t file: %s\n", yytfilen);
#ifdef YYDEBUG
										fclose(errfile);
#endif
	  return(0);          }
	  for (ti=redcnt-1; ti>=0; ti--) {
	    tj = svdprd[redseq[ti]];
	    while (strcmp(svdnams[tj], "$EOP"))
	      fprintf(yytfilep, "%s ", svdnams[tj++]);
	    fprintf(yytfilep, "\n");
	  }
	  fclose(yytfilep);
#endif

#ifdef YYDEBUG
	fclose(errfile);
#endif
	return (0);
      }
    }


    if (n == 0) {        /* error situation */
      switch (pcyyerrfl) {
	case WAS0ERR:          /* an error just occurred */
	  yyerror("syntax error");
	    ++pcyyerrct;
	case WAS1ERR:
	case WAS2ERR:           /* try again */
	  pcyyerrfl = 3;
	   /* find a state for a legal shift action */
	  while (yyps >= statestack) {
	     n = yypact[*yyps] + YYERRCODE;
	     if (n >= 0 && n < YYLAST && yychk[yyact[n]] == YYERRCODE) {
	       tmpstate = yyact[n];  /* simulate a shift of "error" */
	       goto enstack;
	    }
	     n = yypact[*yyps];


	     /* the current yyps has no shift on "error", pop stack */
#ifdef YYDEBUG
	    fprintf(errfile, "error: pop state %d, recover state %d\n", *yyps, yyps[-1]);
#endif
	     --yyps;
	     --yypv;
	   }


	   yyabort:

#ifdef YYASTFLAG
	      yytfilep = fopen(yytfilen, "w");
	      if (yytfilep == NULL) {
		fprintf(stderr, "Can't open t file: %s\n", yytfilen);
		return(1);              }
	      for (ti=1; ti<redcnt; ti++) {
		tj = svdprd[redseq[ti]];
		while (strcmp(svdnams[tj], "$EOP"))
		  fprintf(yytfilep, "%s ", svdnams[tj++]);
		fprintf(yytfilep, "\n");
	      }
	      fclose(yytfilep);
#endif

	     return(1);


	 case WAS3ERR:  /* clobber input char */
#ifdef YYDEBUG
	  fprintf(errfile, "error: discard token %d\n", pcyytoken);
#endif
	  if (pcyytoken == 0) goto yyabort; /* quit */
	   pcyytoken = -1;
	   goto newstate;      } /* switch */
    } /* if */


    /* reduction, given a production n */
#ifdef YYDEBUG
    fprintf(errfile, "reduce with rule %d\n", n);
#endif
#ifdef YYASTFLAG
    if ( redcnt<YYREDMAX ) redseq[redcnt++] = n;
#endif
    yyps -= yyr2[n];
    yypvt = yypv;
    yypv -= yyr2[n];
    yyval = yypv[1];
    m = n;
    /* find next state from goto table */
    n = yyr1[n];
    j = yypgo[n] + *yyps + 1;
    if (j>=YYLAST || yychk[ tmpstate = yyact[j] ] != -n) tmpstate = yyact[yypgo[n]];
    switch (m) { /* actions associated with grammar rules */
       $A
	  }
    goto enstack;
}
